/*
 *                   jfjji,.           H A M M E R H E A D  S H A R K W A R E
 *                  ,#######EL:                  http://www.hhsw.de
 *                   .,j######Kj       
 *                    ;W########G:     This  code  is  free software; you can
 *                   j#####G ,D#L:     redistribute it and/or modify it under
 *             .,;;,G#####D.           the  terms  of  the GNU General Public
 *           jE##########G             License   as  published  by  the  Free
 *             .,W######D.             Software  Foundation; either version 2
 *             :L#####K##G             of  the  License,  or (at your option)
 *           .f#####G;.t##:            any later version.
 *         ;L###ELi.    ,D,            
 *       iEEGWj                        This  code  is distributed in the hope
 *      tW;                            that  it  will  be useful, but without
 *     jf                              any warranty; without even the implied
 *    .Kt                              warranty of merchantability or fitness
 *    i:                               for  a particular purpose. See the GNU
 *    ;                                General   Public   License   for  more
 *    .                                details (http://www.gnu.org).
 */
#ifndef bbdock_Dock_hh
#define bbdock_Dock_hh

#include <unistd.h>
#include <string>

#include <X11/Xlib.h>
#include <X11/xpm.h>
#include <X11/Xutil.h>
#include <X11/extensions/shape.h>

#include "Icon.hh"

namespace bbdock
{
	// forward declaration
	class Slot;

	/**
	 * Dock manages a number of Slot object
	 *
	 * @author mf@hhsw.de
	 * @version 0.06
	 */
	class Dock
	{
		public:
			inline const int &getBitsPerPixel() const { return bitsperpixel; }
			inline Display *getDisplay() const { return display; }
			inline const int &getScreen() const { return screen; }
			inline const GC &getGC() const { return gc; }
			inline const int &getSlotWidth() const { return slotwidth; }
			inline const int &getSlotHeight() const { return slotheight; }
			inline const int &getScreenWidth() const { return screenwidth; }
			inline const int &getScreenHeight() const { return screenheight; }

			Dock( int = 64, int = 64 );
			virtual ~Dock();
			virtual bool add( Icon * );
			virtual void run();
			static void send( const char *, const char *, int );
			static void changeIcon( const char *, const char * );

		private:
			Display	*display;
			int		screen;
			GC 		gc;
			int		bitsperpixel;
			int		slotwidth;
			int		slotheight;
			int		screenwidth;
			int		screenheight;
			Slot	*first;
			
			void client( XEvent * );
	};
}

#endif
